/*

    File: Main.cpp
    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <windows.h>
#include <gl/gl.h>

#include "../m_foundation/main.h"
//#include "../m_foundation/const.h"
//#include "../m_math3d/quat.h"
//#include "../m_math3d/vector.h"
//#include "../m_math3d/matrix.h"

#include "scriptwnd.h"
#include "scriptmenu.h"
#include "mesh.h"
#include "script.h"

// **************** APPLICATION MAIN CALLS ****************

bool Init_Application3D(void) {

//foundation init

	CVar_Exec("ConsoleFont font.bmp");
	overrideCameraKeys = 1;

//opengl init

	glEnable(GL_DEPTH_TEST);

	glEnable(GL_CULL_FACE);

	if (found_GL_EXT_separate_specular_color) {
		glLightModelf(GL_LIGHT_MODEL_COLOR_CONTROL_EXT, GL_SEPARATE_SPECULAR_COLOR_EXT);
	}

	const static float fv0001[] = {0,0,0,1};
	const static float fv1111[] = {1,1,1,1};
	const static float materialShininess = 10.f;
	const static float materialSpecular[] = {0.2f, 0.15f, 0.1f, 1};
	const static float materialAmbient[] = {0.3f, 0.3f, 0.3f, 1};

	glEnable(GL_TEXTURE);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	
	glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER, 1.f);
	glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, 0.f);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, fv0001);

	glMaterialf(GL_FRONT, GL_SHININESS, materialShininess);
	glMaterialfv(GL_FRONT, GL_AMBIENT, fv1111);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, fv1111);
	glMaterialfv(GL_FRONT, GL_SPECULAR, materialSpecular);
	glMaterialfv(GL_FRONT, GL_EMISSION, fv0001);

	glLightfv(GL_LIGHT0, GL_AMBIENT, materialAmbient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, fv1111);
	glLightfv(GL_LIGHT0, GL_SPECULAR, fv1111);

//script editor init

	if (!scriptWndInit()) return false;
	if (!scriptMenuInit()) return false;

	scriptWndLoad("tree.script");

	runScript();

	return true;
}

void Update_Application3D(void) {
	meshRender();
}

void Shutdown_Application3D(void) {
	scriptMenuKill();
	scriptWndKill();
}
